/* Sistemas Integrados TECNISA

Nome: 02CQ_GERTRGO_LOG_CDP_ORDPRODUCAO

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   27/04/2005 - Joo Paulo
*/


/* Tabela ORDPRODUCAO: Ordem de Producao*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ORDPRODUCAO*/
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Ordem de Producao,
             utilizando a tabela Geral de Logs de Operaes */


CREATE OR REPLACE TRIGGER LOG_CDP_ORDPRODUCAO
AFTER DELETE OR INSERT OR UPDATE
ON ORDPRODUCAO FOR EACH ROW
DECLARE
  V_USUARIO         VARCHAR2(40);
  V_TIPO            VARCHAR2(1);
  V_ITPESQ          VARCHAR2(40);
  V_DESC            VARCHAR2(300);
  V_CDFILLOGOPER    VARCHAR2(4);
  V_DTOPER          DATE;
  V_STIDSIT         VARCHAR2(20);
  V_STIDTIPO        VARCHAR2(20);
  V_STCONFIRMAOP    VARCHAR2(3);
  V_CDARVPROD       VARCHAR2(20);

  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_DESC     := '';
   V_STIDSIT  := '';
   V_STIDTIPO := '';
   V_TIPO     := '0';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_USUARIO);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF NOT V_USUARIO IS NULL THEN
      IF DELETING  THEN
         V_TIPO := '3';

         SELECT CDARVPROD INTO V_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :OLD.CDPRODUTO;

         V_DESC   := 'Filial= '     || :OLD.CDFILIAL     || ' ' ||
                     'OP= '         || :OLD.NRORDPROD    || ' ' ||
                     'SubOP= '      || :OLD.NRSUBORDPROD || ' ' ||
                     'Prod= '       || V_CDARVPROD       || ' ' ||
                     'ProcFabric= ' || :OLD.CDPROCFABRIC || ' ' ||
                     'Lote= '       || :OLD.NRLOTEESTQ   || ' ' ||
                     'QtdePrev= '   || ROUND(:OLD.QTAPRODPREOP, 5) || ' ' ||
                     'DtEmis= '     || TO_CHAR(:OLD.DTGERORDPROD);


         IF :OLD.IDSITORDPROD = '1' THEN
            V_DESC := V_DESC || ' Sit= ' || 'Pend';
         END IF;
         IF :OLD.IDSITORDPROD = '2' THEN
            V_DESC := V_DESC || ' Sit= ' || 'And';
         END IF;
         IF :OLD.IDSITORDPROD = '3' THEN
            V_DESC := V_DESC || ' Sit= ' || 'Conc';
         END IF;
         IF :OLD.IDSITORDPROD = '4' THEN
            V_DESC := V_DESC || ' Sit= ' || 'Canc';
         END IF;

         IF :OLD.IDTIPORDPROD = '1' THEN
             V_DESC := V_DESC || ' Tipo= ' || 'Carteira Pedidos';
         END IF;
         IF :OLD.IDTIPORDPROD = '2' THEN
             V_DESC := V_DESC || ' Tipo= ' || 'Inc Manual';
         END IF;
         IF :OLD.IDTIPORDPROD = '3' THEN
             V_DESC := V_DESC || ' Tipo= ' || 'PCP';
         END IF;
         IF :OLD.IDTIPORDPROD = '4' THEN
             V_DESC := V_DESC || ' Tipo= ' || 'Est Mnimo';
         END IF;

         V_ITPESQ  := :OLD.CDFILIAL || :OLD.NRORDPROD || :OLD.NRSUBORDPROD;
         V_CDFILLOGOPER := :OLD.CDFILIAL;
      ELSE
         IF UPDATING THEN

            SELECT CDARVPROD INTO V_CDARVPROD
            FROM PRODUTO
            WHERE CDPRODUTO = :OLD.CDPRODUTO;

            IF (:OLD.CDPROCFABRIC <> :NEW.CDPROCFABRIC) OR
               (:OLD.NRLOTEESTQ   <> :NEW.NRLOTEESTQ)   OR
               (:OLD.QTAPRODPREOP <> :NEW.QTAPRODPREOP) OR
               (:OLD.IDSITORDPROD <> :NEW.IDSITORDPROD) OR
               (:OLD.DTHRINIREAOP <> :NEW.DTHRINIREAOP) OR
               (:OLD.DTHRFIMREAOP <> :NEW.DTHRFIMREAOP) OR
               (:OLD.NRPRIORDADOP <> :NEW.NRPRIORDADOP) OR
               (:OLD.IDCONFIRMAOP <> :NEW.IDCONFIRMAOP) OR
               (:OLD.CDPLANPRODOP <> :NEW.CDPLANPRODOP) THEN


               V_DESC   := 'Filial= '     || :OLD.CDFILIAL     || ' ' ||
                           'OP= '         || :OLD.NRORDPROD    || ' ' ||
                           'SubOP= '      || :OLD.NRSUBORDPROD || ' ' ||
                           'Prod= '       || V_CDARVPROD       || ' ' ||
                           'ProcFabric= ' || :OLD.CDPROCFABRIC || ' ' ||
                           'Lote= '       || :OLD.NRLOTEESTQ;

               IF (:OLD.QTAPRODPREOP <> :NEW.QTAPRODPREOP) THEN
                   V_DESC := V_DESC || ' QtdePrev= ' || ROUND(:OLD.QTAPRODPREOP, 5);
               END IF;
               IF (:OLD.CDPLANPRODOP <> :NEW.CDPLANPRODOP) THEN
                  V_DESC := V_DESC || ' PlanoProd= ' || :OLD.CDPLANPRODOP;
               END IF;
               IF (:OLD.DTHRINIREAOP <> :NEW.DTHRINIREAOP) THEN
                  V_DESC := V_DESC || ' DtIni= '     || TO_CHAR(:OLD.DTHRINIREAOP);
               END IF;
               IF (:OLD.DTHRFIMPREOP <> :NEW.DTHRFIMPREOP) THEN
                  V_DESC := V_DESC || ' DtConc= '    || TO_CHAR(:OLD.DTHRFIMPREOP);
               END IF;
               IF (NVL(:OLD.NRPRIORDADOP,'') <> NVL(:NEW.NRPRIORDADOP,'')) THEN
                  V_DESC := V_DESC || ' Prior= '   || :OLD.NRPRIORDADOP;
               END IF;

               IF (:OLD.IDSITORDPROD <> :NEW.IDSITORDPROD) THEN
                   IF :NEW.IDSITORDPROD = '1' THEN
                      V_DESC := V_DESC || ' Sit= ' || 'Pend';
                   END IF;
                   IF :NEW.IDSITORDPROD = '2' THEN
                      V_DESC := V_DESC || ' Sit= ' || 'And';
                   END IF;
                   IF :NEW.IDSITORDPROD = '3' THEN
                      V_DESC := V_DESC || ' Sit= ' || 'Conc';
                   END IF;
                   IF :NEW.IDSITORDPROD = '4' THEN
                      V_DESC := V_DESC || ' Sit= ' || 'Canc';
                   END IF;
               END IF;

               IF (:OLD.IDCONFIRMAOP <> :NEW.IDCONFIRMAOP) THEN
                  IF :OLD.IDCONFIRMAOP = 'S' THEN
                     V_DESC := V_DESC || ' Conf= ' || 'Sim';
                  END IF;
                  IF :OLD.IDCONFIRMAOP = 'N' THEN
                     V_DESC := V_DESC || ' Conf= ' || 'No';
                  END IF;
               END IF;
            END IF;

            V_ITPESQ  := :OLD.CDFILIAL || :OLD.NRORDPROD || :OLD.NRSUBORDPROD;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_TIPO := '2';
         ELSE
            IF INSERTING THEN

               SELECT CDARVPROD INTO V_CDARVPROD
               FROM PRODUTO
               WHERE CDPRODUTO = :NEW.CDPRODUTO;
               V_TIPO := '1';

               V_DESC   := 'Filial= '     || :NEW.CDFILIAL     || ' ' ||
                           'OP= '         || :NEW.NRORDPROD    || ' ' ||
                           'SubOP= '      || :NEW.NRSUBORDPROD || ' ' ||
                           'Prod= '       || V_CDARVPROD       || ' ' ||
                           'ProcFabric= ' || :NEW.CDPROCFABRIC || ' ' ||
                           'Lote= '       || :NEW.NRLOTEESTQ   || ' ' ||
                           'QtdePrev= '   || ROUND(:NEW.QTAPRODPREOP, 5) || ' ' ||
                           'PlanoProd= '  || :NEW.CDPLANPRODOP || ' ' ||
                           'DtEmis= '     || TO_CHAR(:NEW.DTGERORDPROD);

               IF :NEW.IDTIPORDPROD = '1' THEN
                   V_DESC := V_DESC || ' Tipo= ' || 'Carteira Pedidos';
               END IF;
               IF :NEW.IDTIPORDPROD = '2' THEN
                   V_DESC := V_DESC || ' Tipo= ' || 'Inc Manual';
               END IF;
               IF :NEW.IDTIPORDPROD = '3' THEN
                   V_DESC := V_DESC || ' Tipo= ' || 'PCP';
               END IF;
               IF :NEW.IDTIPORDPROD = '4' THEN
                   V_DESC := V_DESC || ' Tipo= ' || 'Est Mnimo';
               END IF;

               IF :NEW.IDCONFIRMAOP = 'S' THEN
                  V_DESC := V_DESC || ' Conf= ' || 'Sim';
               END IF;
               IF :NEW.IDCONFIRMAOP = 'N' THEN
                  V_DESC := V_DESC || ' Conf= ' || 'No';
               END IF;


               V_ITPESQ  := :NEW.CDFILIAL || :NEW.NRORDPROD || :NEW.NRSUBORDPROD;
               V_CDFILLOGOPER := :NEW.CDFILIAL;
            END IF;
         END IF;
      END IF;

      IF V_TIPO <> '0' THEN
         IF NOT V_DESC IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('ORDPRODUCAO', V_DTOPER, V_USUARIO,
                V_TIPO,       V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_ORDPRODUCAO','4.05.125'); END;
/

