/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 001_SUPCABO.sql

Descrio:
Deleta os dados da tabela PRODFORN e PRODFORNCOMP, para os fornecedores e
produtos que no existem nota fiscal de compra e de entrada cadastradas.
Os nveis deletados so os seguintes:
1.01.19.018.
1.04.01. 
1.04.06.  
1.05.02.012.   
1.05.03.045.   
2.03.11.008.   
4.01.02.031.

Criao:
24/07/2008 Raquel Cunha
*/

DECLARE
   V_TOTAL_COMMIT NUMBER := 500;
   V_QTDE_COMMIT NUMBER := 0;
BEGIN
   FOR C_PRODFORNCOMP IN
      (SELECT PRODFORNCOMP.ROWID
       FROM PRODFORNCOMP
       WHERE EXISTS (SELECT 1
                     FROM PRODUTO
                     WHERE PRODUTO.CDARVPROD LIKE '10119018%'
                       AND PRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL)
         AND NOT EXISTS (SELECT 1
                         FROM NOTAFISCAL, ITEMPRODUTO
                         WHERE PRODFORNCOMP.CDFORNECED = NOTAFISCAL.CDFORNECED
                           AND NOTAFISCAL.CDTIPOOPER = '01'
                           AND NOTAFISCAL.IDENTRSAIDOP = 'E'
                           AND NOTAFISCAL.CDFILIAL = ITEMPRODUTO.CDFILIAL
                           AND NOTAFISCAL.NRLANCTONF = ITEMPRODUTO.NRLANCTONF
                           AND ITEMPRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL))
   LOOP
      DELETE FROM PRODFORNCOMP
      WHERE PRODFORNCOMP.ROWID = C_PRODFORNCOMP.ROWID;
      IF V_QTDE_COMMIT >= V_TOTAL_COMMIT THEN
         COMMIT;
         V_QTDE_COMMIT := 0;
      ELSE
         V_QTDE_COMMIT := V_QTDE_COMMIT + 1;
      END IF;
   END LOOP;

   COMMIT;
   V_QTDE_COMMIT := 0;

   FOR C_PRODFORNCOMP IN
      (SELECT PRODFORNCOMP.ROWID
       FROM PRODFORNCOMP
       WHERE EXISTS (SELECT 1
                     FROM PRODUTO
                     WHERE PRODUTO.CDARVPROD LIKE '10401%'
                       AND PRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL)
         AND NOT EXISTS (SELECT 1
                         FROM NOTAFISCAL, ITEMPRODUTO
                         WHERE PRODFORNCOMP.CDFORNECED = NOTAFISCAL.CDFORNECED
                           AND NOTAFISCAL.CDTIPOOPER = '01'
                           AND NOTAFISCAL.IDENTRSAIDOP = 'E'
                           AND NOTAFISCAL.CDFILIAL = ITEMPRODUTO.CDFILIAL
                           AND NOTAFISCAL.NRLANCTONF = ITEMPRODUTO.NRLANCTONF
                           AND ITEMPRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL))
   LOOP
      DELETE FROM PRODFORNCOMP
      WHERE PRODFORNCOMP.ROWID = C_PRODFORNCOMP.ROWID;
      IF V_QTDE_COMMIT >= V_TOTAL_COMMIT THEN
         COMMIT;
         V_QTDE_COMMIT := 0;
      ELSE
         V_QTDE_COMMIT := V_QTDE_COMMIT + 1;
      END IF;
   END LOOP;

   COMMIT;
   V_QTDE_COMMIT := 0;

   FOR C_PRODFORNCOMP IN
      (SELECT PRODFORNCOMP.ROWID
       FROM PRODFORNCOMP
       WHERE EXISTS (SELECT 1
                     FROM PRODUTO
                     WHERE PRODUTO.CDARVPROD LIKE '10406%'
                       AND PRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL)
         AND NOT EXISTS (SELECT 1
                         FROM NOTAFISCAL, ITEMPRODUTO
                         WHERE PRODFORNCOMP.CDFORNECED = NOTAFISCAL.CDFORNECED
                           AND NOTAFISCAL.CDTIPOOPER = '01'
                           AND NOTAFISCAL.IDENTRSAIDOP = 'E'
                           AND NOTAFISCAL.CDFILIAL = ITEMPRODUTO.CDFILIAL
                           AND NOTAFISCAL.NRLANCTONF = ITEMPRODUTO.NRLANCTONF
                           AND ITEMPRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL))
   LOOP
      DELETE FROM PRODFORNCOMP
      WHERE PRODFORNCOMP.ROWID = C_PRODFORNCOMP.ROWID;
      IF V_QTDE_COMMIT >= V_TOTAL_COMMIT THEN
         COMMIT;
         V_QTDE_COMMIT := 0;
      ELSE
         V_QTDE_COMMIT := V_QTDE_COMMIT + 1;
      END IF;
   END LOOP;

   COMMIT;
   V_QTDE_COMMIT := 0;

   FOR C_PRODFORNCOMP IN
      (SELECT PRODFORNCOMP.ROWID
       FROM PRODFORNCOMP
       WHERE EXISTS (SELECT 1
                     FROM PRODUTO
                     WHERE PRODUTO.CDARVPROD LIKE '10502012%'
                       AND PRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL)
         AND NOT EXISTS (SELECT 1
                         FROM NOTAFISCAL, ITEMPRODUTO
                         WHERE PRODFORNCOMP.CDFORNECED = NOTAFISCAL.CDFORNECED
                           AND NOTAFISCAL.CDTIPOOPER = '01'
                           AND NOTAFISCAL.IDENTRSAIDOP = 'E'
                           AND NOTAFISCAL.CDFILIAL = ITEMPRODUTO.CDFILIAL
                           AND NOTAFISCAL.NRLANCTONF = ITEMPRODUTO.NRLANCTONF
                           AND ITEMPRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL))
   LOOP
      DELETE FROM PRODFORNCOMP
      WHERE PRODFORNCOMP.ROWID = C_PRODFORNCOMP.ROWID;
      IF V_QTDE_COMMIT >= V_TOTAL_COMMIT THEN
         COMMIT;
         V_QTDE_COMMIT := 0;
      ELSE
         V_QTDE_COMMIT := V_QTDE_COMMIT + 1;
      END IF;
   END LOOP;

   COMMIT;
   V_QTDE_COMMIT := 0;

   FOR C_PRODFORNCOMP IN
      (SELECT PRODFORNCOMP.ROWID
       FROM PRODFORNCOMP
       WHERE EXISTS (SELECT 1
                     FROM PRODUTO
                     WHERE PRODUTO.CDARVPROD LIKE '10503045%'
                       AND PRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL)
         AND NOT EXISTS (SELECT 1
                         FROM NOTAFISCAL, ITEMPRODUTO
                         WHERE PRODFORNCOMP.CDFORNECED = NOTAFISCAL.CDFORNECED
                           AND NOTAFISCAL.CDTIPOOPER = '01'
                           AND NOTAFISCAL.IDENTRSAIDOP = 'E'
                           AND NOTAFISCAL.CDFILIAL = ITEMPRODUTO.CDFILIAL
                           AND NOTAFISCAL.NRLANCTONF = ITEMPRODUTO.NRLANCTONF
                           AND ITEMPRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL))
   LOOP
      DELETE FROM PRODFORNCOMP
      WHERE PRODFORNCOMP.ROWID = C_PRODFORNCOMP.ROWID;
      IF V_QTDE_COMMIT >= V_TOTAL_COMMIT THEN
         COMMIT;
         V_QTDE_COMMIT := 0;
      ELSE
         V_QTDE_COMMIT := V_QTDE_COMMIT + 1;
      END IF;
   END LOOP;

   COMMIT;
   V_QTDE_COMMIT := 0;

   FOR C_PRODFORNCOMP IN
      (SELECT PRODFORNCOMP.ROWID
       FROM PRODFORNCOMP
       WHERE EXISTS (SELECT 1
                     FROM PRODUTO
                     WHERE PRODUTO.CDARVPROD LIKE '20311008%'
                       AND PRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL)
         AND NOT EXISTS (SELECT 1
                         FROM NOTAFISCAL, ITEMPRODUTO
                         WHERE PRODFORNCOMP.CDFORNECED = NOTAFISCAL.CDFORNECED
                           AND NOTAFISCAL.CDTIPOOPER = '01'
                           AND NOTAFISCAL.IDENTRSAIDOP = 'E'
                           AND NOTAFISCAL.CDFILIAL = ITEMPRODUTO.CDFILIAL
                           AND NOTAFISCAL.NRLANCTONF = ITEMPRODUTO.NRLANCTONF
                           AND ITEMPRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL))
   LOOP
      DELETE FROM PRODFORNCOMP
      WHERE PRODFORNCOMP.ROWID = C_PRODFORNCOMP.ROWID;
      IF V_QTDE_COMMIT >= V_TOTAL_COMMIT THEN
         COMMIT;
         V_QTDE_COMMIT := 0;
      ELSE
         V_QTDE_COMMIT := V_QTDE_COMMIT + 1;
      END IF;
   END LOOP;

   COMMIT;
   V_QTDE_COMMIT := 0;

   FOR C_PRODFORNCOMP IN
      (SELECT PRODFORNCOMP.ROWID
       FROM PRODFORNCOMP
       WHERE EXISTS (SELECT 1
                     FROM PRODUTO
                     WHERE PRODUTO.CDARVPROD LIKE '40102031%'
                       AND PRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL)
         AND NOT EXISTS (SELECT 1
                         FROM NOTAFISCAL, ITEMPRODUTO
                         WHERE PRODFORNCOMP.CDFORNECED = NOTAFISCAL.CDFORNECED
                           AND NOTAFISCAL.CDTIPOOPER = '01'
                           AND NOTAFISCAL.IDENTRSAIDOP = 'E'
                           AND NOTAFISCAL.CDFILIAL = ITEMPRODUTO.CDFILIAL
                           AND NOTAFISCAL.NRLANCTONF = ITEMPRODUTO.NRLANCTONF
                           AND ITEMPRODUTO.CDPRODUTO = PRODFORNCOMP.CDPRODCOMPL))
   LOOP
      DELETE FROM PRODFORNCOMP
      WHERE PRODFORNCOMP.ROWID = C_PRODFORNCOMP.ROWID;
      IF V_QTDE_COMMIT >= V_TOTAL_COMMIT THEN
         COMMIT;
         V_QTDE_COMMIT := 0;
      ELSE
         V_QTDE_COMMIT := V_QTDE_COMMIT + 1;
      END IF;
   END LOOP;

   COMMIT;
   V_QTDE_COMMIT := 0;

   DELETE FROM PRODFORN
   WHERE NOT EXISTS (SELECT 1
                     FROM PRODFORNCOMP
                     WHERE PRODFORNCOMP.CDFORNECED = PRODFORN.CDFORNECED
                       AND PRODFORNCOMP.CDPRODUTO = PRODFORN.CDPRODUTO);
   COMMIT;
END;
/


